"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Burger = void 0;

var _react = require("react");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var area = 48;
var duration = 0.4;
var timing = 'cubic-bezier(0, 0, 0, 1)';
var translate = 4.6325;

var Burger = function Burger(_ref) {
  var _ref$color = _ref.color,
      color = _ref$color === void 0 ? '#000' : _ref$color,
      _ref$direction = _ref.direction,
      direction = _ref$direction === void 0 ? 'left' : _ref$direction,
      _ref$hideOutline = _ref.hideOutline,
      hideOutline = _ref$hideOutline === void 0 ? true : _ref$hideOutline,
      onToggle = _ref.onToggle,
      render = _ref.render,
      _ref$rounded = _ref.rounded,
      rounded = _ref$rounded === void 0 ? false : _ref$rounded,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 32 : _ref$size;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      toggled = _useState2[0],
      toggle = _useState2[1];

  var width = Math.max(12, Math.min(area, size));
  var room = Math.round((area - width) / 2);
  var barHeightRaw = width / 12;
  var barHeight = Math.round(barHeightRaw);
  var marginRaw = width / 4.5;
  var margin = Math.round(marginRaw);
  var height = barHeight * 3 + margin * 2;
  var topOffset = Math.round((area - height) / 2);
  var deviation = barHeightRaw - barHeight + (marginRaw - margin);
  var move = width / translate - deviation / (4 / 3);
  var burgerStyles = {
    cursor: 'pointer',
    height: "".concat(area, "px"),
    position: 'relative',
    transition: "".concat(duration, "s ").concat(timing),
    userSelect: 'none',
    width: "".concat(area, "px")
  };
  var barStyles = {
    background: color,
    height: "".concat(barHeight, "px"),
    left: "".concat(room, "px"),
    position: 'absolute',
    width: "".concat(width, "px")
  };

  if (hideOutline) {
    burgerStyles['outline'] = 'none';
  }

  if (rounded) {
    barStyles['borderRadius'] = '9em';
  }

  var handler = function handler() {
    if (onToggle) {
      onToggle(!toggled);
    }

    toggle(!toggled);
  };

  return render({
    barHeight: barHeight,
    barStyles: barStyles,
    burgerStyles: burgerStyles,
    duration: duration,
    handler: handler,
    isLeft: direction === 'left',
    margin: margin,
    move: move,
    timing: timing,
    toggled: toggled,
    topOffset: topOffset
  });
};

exports.Burger = Burger;